unit unitMy;

interface
uses
  Windows, SysUtils, Forms, Grids, Clipbrd;

procedure Delay(ms : LongWord);
function FileToStr(FileName: String): String;
procedure StrToFile(FileName: String; Text: String);
function FileToBuff(FileName: String; var Data: Array of Byte): Integer;
procedure BuffToFile(FileName: String; Data: Array of Byte; CountByte: Integer);
function TabToStr(TabGrid: TStringGrid; Top,Bottom,Left,Right: Integer): String;
procedure StrToTab(TabGrid: TStringGrid; PosCol, PosRow: Integer; Data: String);
procedure TabToClipboard(TabGrid: TStringGrid);
procedure ClipboardToTab(TabGrid: TStringGrid; PosCol, PosRow: Integer);
function CRC(Pole: array of Byte; StartPoz, StopPoz: Integer): Byte;
function sTwo(pom:Integer): string;
function sThree(pom:Integer): string;
function sFour(pom:Integer): string;
function TestChar(znak: char): Boolean;
function TestCharX(znak: char): Boolean;
function HexToInt(Num: string): Integer;
function NowTimeToInt: Integer;
function DifTimeInt(OldTime,NowTime: Integer): Integer;
function TimeToInt(Hour,Min,Sec,Msec: Integer): Integer;
function sTimeToInt(Time: String): Integer;
function TestTime(Hour, Min, Sec, Msec: Integer): Boolean;
function HexToArray(sData: string; var Data: array of Byte): Integer;
function HexToArrayX(sData: string; var Data: array of Integer): Integer;
function ArrayToHex(Data: array of Byte; LenData: Integer): string;
procedure HexArrayForm(var sData: string);
function ArrayComp(Array1,Array2: array of Integer; LenArray: Integer): Boolean;
procedure ArrayCopy(DataFrom: Array of Byte;var DataTo: Array of Byte; LenArray: Integer);
function iMin(iVal1,iVal2: Integer):Integer;
function iMax(iVal1,iVal2: Integer):Integer;

implementation

procedure Delay(ms : LongWord);
var kdy : LongWord;
begin
 kdy := GetTickCount + ms;
 while GetTickCount < kdy do Application.ProcessMessages;
end;

// Kopiruje Tabulku StringGrid do Stringu ve tvaru pro Schranku kompatibilni s Excelem
function TabToStr(TabGrid: TStringGrid; Top,Bottom,Left,Right: Integer): String;
var PomS,PomX: String;
    x,y: Integer;
begin
  PomS:='';
  for x:=Top to Bottom do
  begin
    for y:=Left to Right do
    begin
      if y<Right then PomX:=#9 else PomX:=#13#10;
      PomS:=PomS+TabGrid.Cells[y,x]+PomX;
    end;
  end;
  result:=PomS;
end;

// Kopiruje text ve formatu Schranky kompatibilni s Excelem do tabulky StringGrid
procedure StrToTab(TabGrid: TStringGrid; PosCol, PosRow: Integer; Data: String);
var i,x,y,delka: Integer;
    PomS: String;
begin
  i:=1;
  x:=0;
  y:=0;
  PomS:='';
  delka:=Length(data);
  while i<=delka do
  begin
    if(data[i]<>#13)then
    begin
      if(data[i]<>#10)then
      begin
        if(data[i]<>#9)then
        begin
          PomS:=PomS+data[i];
          inc(i);
        end
        else
        begin
          TabGrid.Cells[PosCol+x,PosRow+y]:=PomS;
          inc(x);
          PomS:='';
          inc(i);
        end;
      end
      else
      begin
        if(i+5<delka)then inc(y);
        x:=0;
        inc(i);
      end;
    end
    else
    begin
      TabGrid.Cells[PosCol+x,PosRow+y]:=PomS;
      inc(x);
      PomS:='';
      inc(i);
    end;
  end;
end;

// Kopiruje Tabulku StringGrid do Schranky ve tvaru kompatibilnim s Excelem
procedure TabToClipboard(TabGrid: TStringGrid);
var PomS,PomX: String;
    x,y: Integer;
begin
  PomS:='';
  for x:=TabGrid.Selection.Top to TabGrid.Selection.Bottom do
  begin
    for y:=TabGrid.Selection.Left to TabGrid.Selection.Right do
    begin
      if y<TabGrid.Selection.Right then PomX:=#9 else PomX:=#13#10;
      PomS:=PomS+TabGrid.Cells[y,x]+PomX;
    end;
  end;
  Clipboard.AsText:=PomS;
end;

// Kopiruje text ze schranky Schranky ve formatu kompatibilnim s Excelem do tabulky StringGrid
procedure ClipboardToTab(TabGrid: TStringGrid; PosCol, PosRow: Integer);
var i,x,y,delka: Integer;
    Data,PomS: String;
begin
  i:=1;
  x:=0;
  y:=0;
  PomS:='';
  if Clipboard.HasFormat(CF_TEXT) then
  begin
    Data:=Clipboard.AsText;
    delka:=Length(data);
    while i<=delka do
    begin
      if(data[i]<>#13)then
      begin
        if(data[i]<>#10)then
        begin
          if(data[i]<>#9)then
          begin
            PomS:=PomS+data[i];
            inc(i);
          end
          else
          begin
            TabGrid.Cells[PosCol+x,PosRow+y]:=PomS;
            inc(x);
            PomS:='';
            inc(i);
          end;
        end
        else
        begin
          if(i+5<delka)then inc(y);
          x:=0;
          inc(i);
        end;
      end
      else
      begin
        TabGrid.Cells[PosCol+x,PosRow+y]:=PomS;
        inc(x);
        PomS:='';
        inc(i);
      end;
    end;
  end;
end;

// Funkce vycitajici obsah souboru do stringu
// vraci string
function FileToStr(FileName: String): String;
var
  FromF: file;
  PomS: String;
  NumRead,x: Integer;
  Buf: array[1..1024] of Char;
begin
  PomS:='';
  AssignFile(FromF, FileName);
  Reset(FromF, 1);	// Otevre zdrojovy soubor
  repeat
    BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
    for x:=1 to NumRead do
    begin
      PomS:=PomS+Buf[x];
    end;
  until (NumRead = 0);
  CloseFile(FromF);
  result:=PomS;
end;

// Funkce ukladajici obsah pole do souboru
procedure StrToFile(FileName: String; Text: String);
var
  ToF: file;
  NumWrite,x,i: Integer;
  Buf: array[1..1024] of Char;
begin
  i:=0;
  AssignFile(ToF, FileName);	{ Open output file }
  Rewrite(ToF, 1);	// Otevre pripadne vytvori novy soubor
  for x:=1 to Length(Text) do
  begin
    inc(i);
    Buf[i]:=Text[x];
    if(i=SizeOf(Buf))or(x=Length(Text))then
    begin
      BlockWrite(ToF,Buf,i,NumWrite);
      i:=0;
    end;
  end;
  CloseFile(ToF);
end;

// Funkce vycitajici obsah souboru do pole bytu
// vraci pocet bytu
function FileToBuff(FileName: String; var Data: Array of Byte): Integer;
var
  FromF: file;
  NumRead,x,i: Integer;
  Buf: array[1..1024] of Char;
begin
  i:=0;
  AssignFile(FromF, FileName);
  Reset(FromF, 1);	// Otevre zdrojovy soubor
  repeat
    BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
    for x:=1 to NumRead do
    begin
      Data[i]:=Byte(Buf[x]);
      inc(i);
    end;
  until (NumRead = 0);
  CloseFile(FromF);
  result:=i;
end;

// Funkce ukladajici obsah pole do souboru
procedure BuffToFile(FileName: String; Data: Array of Byte; CountByte: Integer);
var
  ToF: file;
  NumWrite,x,i: Integer;
  Buf: array[1..1024] of Char;
begin
  i:=0;
  AssignFile(ToF, FileName);	{ Open output file }
  Rewrite(ToF, 1);	// Otevre pripadne vytvori novy soubor
  for x:=0 to CountByte-1 do
  begin
    inc(i);
    Buf[i]:=Char(Data[x]);
    if(i=SizeOf(Buf))or(x=CountByte-1)then
    begin
      BlockWrite(ToF,Buf,i,NumWrite);
      i:=0;
    end;
  end;
  CloseFile(ToF);
end;

// Vypocte CRC soucet
function CRC(Pole: array of Byte; StartPoz, StopPoz: Integer): Byte;
var CRCx,x:Byte;
begin
  CRCx:=0;
  for x:=StartPoz to StopPoz do
  begin
    CRCx:=CRCx xor Pole[x];
  end;
  result:=CRCx;
end;

// Prevede cislo integer na 2 znaky textu.
function sTwo(pom:Integer): string;
var s,x: String;
begin
  if (pom<0) or (pom>99) then pom:=0;
  x:=IntToStr(pom);
  if Length(x)=1 then s:='0'+x
  else s:=x;
  result:=s;
end;

// Prevede cislo integer na 3 znaky textu.
function sThree(pom:Integer): string;
var s,x: String;
begin
  if (pom<0) or (pom>999) then pom:=0;
  x:=IntToStr(pom);
  if Length(x)=1 then s:='00'+x
  else if Length(x)=2 then s:='0'+x
  else s:=x;
  result:=s;
end;

// Prevede cislo integer na 4 znaky textu.
function sFour(pom:Integer): string;
var s,x: String;
begin
  if (pom<0) or (pom>9999) then pom:=0;
  x:=IntToStr(pom);
  if Length(x)=1 then s:='000'+x
  else if Length(x)=2 then s:='00'+x
  else if Length(x)=3 then s:='0'+x
  else s:=x;
  result:=s;
end;

function TestChar(znak: char): Boolean;
begin
 znak:=upcase(znak);
 case znak of
  '0'..'9': TestChar:=True;
  'A': TestChar:=True;
  'B': TestChar:=True;
  'C': TestChar:=True;
  'D': TestChar:=True;
  'E': TestChar:=True;
  'F': TestChar:=True;
  else TestChar:=False;
  end;
end;

function TestCharX(znak: char): Boolean;
begin
 znak:=upcase(znak);
 case znak of
  '0'..'9': TestCharX:=True;
  'A': TestCharX:=True;
  'B': TestCharX:=True;
  'C': TestCharX:=True;
  'D': TestCharX:=True;
  'E': TestCharX:=True;
  'F': TestCharX:=True;
  'X': TestCharX:=True;
  else TestCharX:=False;
 end;
end;

function Hex(znak: char): Integer;
begin
 znak:=upcase(znak);
 case znak of
  '0'..'9': Hex := ord(znak)-ord('0');
  'A': Hex := 10;
  'B': Hex := 11;
  'C': Hex := 12;
  'D': Hex := 13;
  'E': Hex := 14;
  'F': Hex := 15;
  else Hex := 0;
 end;
end;

// Prevadi Hex na Integer
function HexToInt(Num: string): Integer;
var Len, Suma, x: Integer;
begin
  Suma:=0;
  Len:=Length(Num);
  for x:=1 to Len do Suma:=16*Suma+Hex(Num[x]);
  result:=Suma;
end;

// Prevadi Hex na Integer vcetne XX
function HexToIntX(Num: string): Integer;
var Len, Suma, x: Integer;
begin
  Suma:=0;
  Len:=Length(Num);
  for x:=1 to Len do
  if(Num[x]<>'X')and(Num[x]<>'x')then Suma:=16*Suma+Hex(Num[x])
  else Suma:=-1;
  result:=Suma;
end;

// Konverze Byte time na integer
function TimeToInt(Hour,Min,Sec,MSec: Integer): Integer;
begin
  result:=3600000*Hour+60000*Min+1000*Sec+MSec;
end;

// Vezme aktualni cas a prevede jej na Integer
function NowTimeToInt: Integer;
var Hour, Min, Sec, MSec: Word;
begin
  DecodeTime(Now, Hour, Min, Sec, MSec);
  result:=TimeToInt(Hour,Min,Sec,Msec);
end;

// Vypocte rozdil dvou casu
function DifTimeInt(OldTime,NowTime: Integer): Integer;
var Hour, Min, Sec, MSec: Word;
begin
  if(NowTime>=OldTime)then result:=NowTime-OldTime
  else result:=TimeToInt(23,59,59,9999)-OldTime+NowTime;
end;

// Konverze textu casu na integer
function sTimeToInt(Time: String): Integer;
var x,delka,Hour,Min,Sec,Msec:Integer;
    PomS: String;
begin
  Hour:=0;
  Min:=0;
  Sec:=0;
  Msec:=0;
  PomS:='';
  delka:=Length(Time);
  if delka>0 then
  begin
    for x:=1 to delka do if(Time[x]<>' ') then PomS:=PomS+Time[x];
    x:=1;
    Time:=PomS;
    delka:=Length(Time);
    try
      PomS:=Time[x];
      if(Time[x+1]<>':')then PomS:=PomS+Time[x+1];
      Hour:=StrToInt(PomS);
      x:=x+Length(PomS)+1;
      if x<delka then
      begin
        PomS:=Time[x]+Time[x+1];
        Min:=StrToInt(PomS);
        x:=x+3;
        if x<delka then
        begin
          PomS:=Time[x]+Time[x+1];
          Sec:=StrToInt(PomS);
          x:=x+3;
          PomS:='';
          while(x<=delka)and(Length(PomS)<4)do
          begin
            PomS:=PomS+Time[x];
            inc(x);
          end;
          while(Length(PomS)<3)do PomS:=PomS+'0';
          if(Length(PomS)>0)then Msec:=StrToInt(PomS);
        end;
      end;
    except
    end;
  end;
  if(Hour<24)and(Min<60)and(Sec<60)and(Msec<1000)then result:=3600000*Hour+60000*Min+1000*Sec+Msec
  else result:=0;
end;

// Test platnosti casu
function TestTime(Hour, Min, Sec, Msec: Integer): Boolean;
begin
  result:=(Hour<24)and(Min<60)and(Sec<60)and(Msec<1000);
end;

// Prevadi Hex na Pole Byte vraci pocet byte
function HexToArray(sData: string; var Data: array of Byte): Integer;
var x,i,Len: Integer;
    sPom: string;
begin
  sPom:='';
  Len:=Length(sData);
  for x:=0 to 7 do Data[x]:=0;
  x:=0;
  for i:=1 to Len do
  begin
    if TestChar(sData[i])then
    begin
      sPom:=sPom+sData[i];
      if Length(sPom)>1 then
      begin
        Data[x]:=HexToInt(sPom);
        sPom:='';
        Inc(x);
      end;
    end
    else
    begin
      if Length(sPom)>0 then
      begin
        Data[x]:=HexToInt(sPom);
        sPom:='';
        Inc(x);
      end;
    end;
  end;
  result:=x;
end;

// Prevadi Hex na Pole Integer vraci pocet byte (XX vraci jako -1)
function HexToArrayX(sData: string; var Data: array of Integer): Integer;
var x,i,Len: Integer;
    sPom: string;
begin
  sPom:='';
  Len:=Length(sData);
  for x:=0 to 7 do Data[x]:=0;
  x:=0;
  for i:=1 to Len do
  begin
    if TestCharX(sData[i])then
    begin
      sPom:=sPom+sData[i];
      if Length(sPom)>1 then
      begin
        Data[x]:=HexToIntX(sPom);
        sPom:='';
        Inc(x);
      end;
    end
    else
    begin
      if Length(sPom)>0 then
      begin
        Data[x]:=HexToIntX(sPom);
        sPom:='';
        Inc(x);
      end;
    end;
  end;
  result:=x;
end;


// Prevede pole Bytu na Hex String
function ArrayToHex(Data: array of Byte; LenData: Integer): string;
var PomS: String;
    x: Integer;
begin
  PomS:='';
  for x:=0 to LenData-1 do
  begin
    PomS:=PomS+IntToHex(Data[x],2)+' ';
  end;
  result:=PomS;
end;

// Oprava formy Hex Retezce f8 fa -> F8 FA
procedure HexArrayForm(var sData: string);
var aData: array [0..63] of Byte;
    LenData: Integer;
begin
  LenData:=HexToArray(sData,aData);
  sData:=ArrayToHex(aData,LenData);
end;

// Funkce pro porovnani dvou Bytovych poli
function ArrayComp(Array1,Array2: array of Integer; LenArray: Integer): Boolean;
var x: Integer;
    Eq: Boolean;
begin
  Eq:=True;
  for x:=0 to LenArray-1 do
  begin
    if(Array1[x]>-1)and(Array2[x]>-1)and(Array1[x]<>Array2[x])then
    begin
      Eq:=False;
      Break;
    end;
  end;
  result:=Eq;
end;

// Procedura pro kopirovani poli
procedure ArrayCopy(DataFrom: Array of Byte;var DataTo: Array of Byte; LenArray: Integer);
var x: Integer;
begin
  for x:=0 to LenArray-1 do DataTo[x]:=DataFrom[x];
end;

// Hledani integer minima
function iMin(iVal1,iVal2: Integer):Integer;
begin
  if(iVal1<iVal2)then result:=iVal1
  else result:=iVal2;
end;

// Hledani integer maxima
function iMax(iVal1,iVal2: Integer):Integer;
begin
  if(iVal1>iVal2)then result:=iVal1
  else result:=iVal2;
end;

end.
